module counter(out, clk, reset);

  parameter WIDTH = 8;

  output [WIDTH-1 : 0] out;
  input 	       clk, reset;

  reg [WIDTH-1 : 0]    out;
  wire 	               clk, reset;

  always @(posedge clk)
    out <= out + 1;

  // The assign and deassign procedural assignment statements allow continuous
  // assignments to be placed onto registers for controlled periods of time.
  // The assign procedural statement overrides procedural assignments to
  // a register. The deassign procedural statement ends a continuous
  // assignment to a register.
  always @reset
    if (reset)
      assign out = 0;
    else
      deassign out;

endmodule // counter
